AreParallel := function(G1, G2)

# returns true if G1 and G2 are parallel

local sglg1, sglg2, sg, A, B, parallel;

#ensure that G1 and G2 are finite abelian groups 
if not IsGroup(G1) or not IsFinite(G1) or not IsAbelian(G1) or not IsGroup(G2) or not IsFinite(G2) or not IsAbelian(G2)then
  Error("Usage: AreParallel(<G1>, <G2>) - where <G1>, <G2> are finite abelian groups\n");
fi;

parallel := true;

sglg1 := List(LatticeSubgroups(G1)!.conjugacyClassesSubgroups, Representative);
sglg2 := List(LatticeSubgroups(G2)!.conjugacyClassesSubgroups, Representative);

for A in Filtered(sglg1, function(sg) return Size(sg) > 1; end) do
  if AreOrthogonal(A, G2) then parallel := false; fi;
od;
if parallel then 
  for B in Filtered(sglg2, function(sg) return Size(sg) > 1; end) do
    if AreOrthogonal(B, G1) then parallel := false; fi;
  od;
fi;

return parallel;

end;
