IsClosed := function(G, A)

local minsl, sgl, t, a;

#ensure that G and A are finite abelian groups and A is a subgroup of G
if not IsGroup(G) or not IsFinite(G) or not IsAbelian(G) or not IsSubgroup(G, A) then
  Error("Usage: IsClosed(<G>, <A>) - where <G> is a finite abelian group and <A> is a subgroup of <G>\n");
fi;

if A = G then return true; fi;

# obtain a list of all subgroups
sgl := List(LatticeSubgroups(G)!.conjugacyClassesSubgroups, Representative);


minsl := MinimalSupergroupsLattice(LatticeSubgroups(G));
t := Position(sgl, TrivialSubgroup(G));
a := Position(sgl, A);

return Size(Filtered(minsl[t]{[1..Size(minsl[t])]}[1], c -> IsSubset(A, sgl[c]))) < 
       Minimum(List(minsl[a]{[1..Size(minsl[a])]}[1], c -> Size(Filtered(minsl[t]{[1..Size(minsl[t])]}[1], d -> IsSubset(sgl[c], sgl[d])))));

end;