IsCoessential := function(G, A, B)

local epi;

#ensure that G, A and B are finite abelian groups and A is a subgroup of G; B is a subgroup of A
if not IsGroup(G) or not IsFinite(G) or not IsAbelian(G) or not IsSubgroup(G, A) or not IsSubgroup(A, B) then
  Error("Usage: IsCoessential(<G>, <A>, <B>) - where <G> is a finite abelian group and B <= A <= G\n");
fi;

if G = TrivialSubgroup(G) then 
  return true;
else 
  epi := NaturalHomomorphismByNormalSubgroup(G, B);
  return IsSuperfluous(Image(epi, G), Image(epi, A));
fi;

end;