IsDirectSummand := function(G, A)

local sgl, B, d;

#ensure that G and A are finite abelian groups and A is a subgroup of G
if not IsGroup(G) or not IsFinite(G) or not IsAbelian(G) or not IsSubgroup(G, A) then
  Error("Usage: IsDirectSummand(<G>, <A>) - where <G> is a finite abelian group and <A> is a subgroup of <G>\n");
fi;

# if A = G then return false; fi;

# obtain a list of all subgroups
sgl := List(LatticeSubgroups(G)!.conjugacyClassesSubgroups, Representative);

d := false;

for B in Filtered(sgl, function(g) return Size(g) = IndexNC(G, A); end) do
  if Intersection(A, B) = TrivialSubgroup(G) then 
    d := true;
    break;
  fi;
od;

return d;

end;
