IsExtending := function(G)

local dsum, closed;

# ensure that the group G is finite and abelian
if not IsGroup(G) or not IsFinite(G) or not IsAbelian(G) then 
  Error("Usage: IsExtending(<G>) - where <G> is a finite abelian group\n");
fi;

dsum := DirectSummands(G);

closed := ClosedSubgroups(G);

return Union(dsum{[1..Size(dsum)]}[1], dsum{[1..Size(dsum)]}[2]) = Set(closed);

end;