IsSuperfluous := function(G, H)

#ensure that G and H are finite abelian groups and H is a subgroup of G
if not IsGroup(G) or not IsFinite(G) or not IsAbelian(G) or not IsSubgroup(G, H) then
  Error("Usage: IsSuperfluous(<G>, <H>) - where <G> is a finite abelian group and <H> is a subgroup of <G>\n");
fi;

if G = TrivialSubgroup(G) then return true;  
			  else return IsSubset(Intersection(MaximalSubgroups(G)), H);
fi;

end;