IsTS := function(G)

local dsum, ts;

# ensure that the group G is finite and abelian
if not IsGroup(G) or not IsFinite(G) or not IsAbelian(G) then 
  Error("Usage: IsTS(<G>) - where <G> is a finite abelian group\n");
fi;

dsum := DirectSummands(G);

ts := TypeSubgroups(G);

return IsSubset(Union(dsum{[1..Size(dsum)]}[1], dsum{[1..Size(dsum)]}[2]),Set(ts));

end;
