TypeSubgroups := function(G)

# returns the list of type subgroups of G

local sgl, sg, P, Y, X, typelist, okx, oky;

#ensure that G is a finite abelian group
if not IsGroup(G) or not IsFinite(G) or not IsAbelian(G) then
  Error("Usage: TypeSubgroups(<G>) - where <G> is a finite abelian group\n");
fi;

sgl := List(LatticeSubgroups(G)!.conjugacyClassesSubgroups, Representative);

typelist := [];

for P in sgl do
  oky := true;
  for Y in Filtered(sgl, function(sg) return IsSubset(sg, P) and not sg = P; end) do
    okx := false;
    for X in Filtered(sgl, function(sg) return IsSubset(Y, sg) and not sg = TrivialSubgroup(G); end) do    
      if AreOrthogonal(P, X) then okx := true; fi;
    od;
    if not okx then oky := false; fi;
  od;
  if oky and not P in typelist then Add(typelist, P); fi;
od;

return typelist;

end;
